#!/bin/bash
# sort given files in given Dir recursively to preconfigured specific targets
#

#definition
prefix=./testdir/
declare -A map
map[pdf]=${prefix}pdf
map[txt]=${prefix}txt
##########################
# main
##########################


# test if source dir is given
if [ ! -e "$1" ]
then
	echo "you need to specify a directory"
	exit -1
fi

# create dir for prefix
mkdir -p $prefix

# auto sorter
# foreach defined key (file.suffix, ex.: .pdf)
for suffix in ${!map[@]}
do
	echo -n "map - $suffix"
	echo " -> ${map[$suffix]}"
	target=${map[$suffix]}
	# create target dir for suffix, ex.: testdir/pdf
	mkdir -p $target
	# search for all files with suffix (ex.: .pdf) in
	# current given source dir and move them into
	# the target dir for suffix (ex.: mv src/test.pdf testdir/pdf/)
	IFS=$'\n'
	for srcfile in $(find $1 -type f -name "*.$suffix" -print)
	do
		targetpath=${target}/"$srcfile"
		targetdir=$(dirname "$targetpath")
		srcdir=$(dirname "$srcfile")
		if [ "$target" == "$srcdir" ]
		then 
			echo -e "\tignoring $srcfile"
		else
			echo -e "\tmoving \"$srcfile\" to \"$targetpath\""
		mkdir -p "$targetdir"
		mv "$srcfile" "$targetpath"
		ln -s "$targetpath" "$srcfile"
	fi
	done
done

